package sk.stuba.fei.uim.oop.spring.mvcenum;

import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;

import java.util.HashMap;
import java.util.Map;

@Controller
@SpringBootApplication
public class MvcEnumApplication implements CommandLineRunner {

    private final Map<Long, Item> items = new HashMap<>();

    public static void main(String[] args) {
        SpringApplication.run(MvcEnumApplication.class, args);
    }

    @Override
    public void run(String... args) {
        for (long i = 0; i < 3; i++) {
            items.put(i, new Item(i, Color.values()[(int) i]));
        }
    }

    @GetMapping("/update/{id}")
    public String update(@PathVariable long id, Model model) {
        model.addAttribute("item", items.get(id));
        model.addAttribute("colors", Color.values());
        return "update";
    }

    @GetMapping("/")
    public String index(Model model) {
        model.addAttribute("items", items.values());
        return "index";
    }

    @PostMapping("/update/{id}")
    public String submit(@PathVariable long id, @ModelAttribute Item item) {
        items.put(id, item);
        return "redirect:/";
    }
}
